#ifndef CHILDLIST_H
#define CHILDLIST_H
#include "farray.h"

class HashNodes {
  private: 
    FArray<Node> nodes; // we allocate exactly the required amount of space.
    HashNodes ( int size ): nodes ( size ) {  }
  friend class ChildList;
};

class ChildList {
  public:
    ChildList ();
    ~ChildList ();
    FArray<Node> &allocate ( int modenr, int size );
  private:
    FArray<HashNodes*> hash;
    int modefirstchild;
  friend class ChildListIterator;
};

class ChildListIterator {
    ChildList *childlist;
    int hashnr, inhashpos;
    int inhashmax;
    void gotonexthash () {
      while ( hashnr < childlist->hash.size () && 
              childlist->hash[hashnr] == NULL )
        hashnr++;
      if ( hashnr < childlist->hash.size () ) {
        inhashpos = 0;
	inhashmax = childlist->hash[hashnr].firstdisabled;
      }
      else
        hashnr = -1;
    }
  public:
    ChildListIterator ( ChildList *_childlist ) { childlist = _childlist; hashnr = 0; gotonexthash (); }
    Node *current () { return hashnr == -1 ? 0 : childlist->hash[hashnr].nodes[inhashpos]; }
    void next () {
      i++;
      if ( i >= inhashmax ) 
        gotonexthash ();
    }
};

#endif
