/***************************************************************************
                       facttable.cpp -  storage for facts
		                        that occur in modes without
					outputs
                             -------------------
    begin                : Wed Mar 22 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "facttable.h"
#include "type.h"

FactTable::FactTable ( int dimensions ) {
  this->dimensions = dimensions;
  if ( dimensions > 1 )
    data = new FMultiArray<FArray<unsigned int> > ( dimensions - 1 );
  else
    data_onedimension = new FArray<unsigned int>;
}

FactTable::~FactTable () {
  delete data;
}

void FactTable::setFact ( INTTYPE *coor, bool value ) {
  int nr = coor[dimensions - 1] / 32, bnr = coor[dimensions - 1] % 32;
  FArray<unsigned int> *a = ( dimensions > 1 ) ? data->element ( coor ) : data_onedimension;
  unsigned int val;
  if ( a )
    val = a->element ( nr );
  else {
    data->insertAt ( coor, a = new FArray<unsigned int> );
    val = 0;
  }
  a->insertAt ( nr, value ? ( val | ( 1 << bnr ) ) : ( val & ~ ( 1 << bnr ) ) );
}
