/***************************************************************************
                          flist.h  -  an implementation of 
			              a very simple single linked
				      list
                             -------------------
    begin                : 2003
    copyright            : (C) 2003 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef FLIST_H
#define FLIST_H
#include <stdlib.h>

template<class T> class FListWalk;

template<class T>
class FList {
  struct FListEl {
    T data;
    FListEl *next;
  };
    FListEl *first, *last;
    int _size;
  public:
    FList<T> () {
      first = last = NULL; _size = 0;
    }
    ~FList<T> () {
      FListEl *walk = first, *temp;
      while ( walk ) {
        temp = walk;
        walk = walk->next;
	delete temp;
      }
    }
    inline bool empty () const {
      return first == NULL;
    }
    inline int size () const {
      return _size;
    }
    void append ( T &value ) {
      FListEl *walk = new FListEl;
      walk->data = value;
      walk->next = NULL;
      if ( last ) {
        last->next = walk;
	last = walk;
      }
      else 
        first = last = walk;
      _size++;
    }
  friend class FListWalk<T>;
};

template<class T>
class FListWalk {
    typename FList<T>::FListEl *walk;
  public:
    FListWalk<T> ( FList<T> *flist ) {
      walk = flist->first;
    }
    void setTo ( FList<T> *flist ) {
      if ( flist )
        walk = flist->first;
      else
        walk = NULL;
    }
    T *current () {
      if ( walk ) 
        return &walk->data;
      return NULL;
    }
    void next () {
      walk = walk->next;
    }
};
#endif
