/***************************************************************************
                          floattable.cpp  -  description
                             -------------------
    begin                : Sun Jul 2 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "floattable.h"

FloatTable::FloatTable ( int maxsize ):
  usedsize ( 0 ) {
  array = new TableElt[maxsize];
}

FloatTable::~FloatTable() {
  delete[] array;
}

bool FloatTable::add ( float number, void *data ) {
  if ( usedsize > 0 && array[usedsize - 1].number >= number )
    return false;
  array[usedsize].number = number;
  array[usedsize].data = data;
  usedsize++;

  return true;
}

int FloatTable::ordernumber ( float number ) {
  int b1 = 0, b2 = usedsize - 1, walk;

  while ( b1 <= b2 ) {
    walk = ( b1 + b2 ) / 2;
    if ( array[walk].number == number )
      return walk;
    if ( array[walk].number < number )
      b1 = walk + 1;
    else
      b2 = walk - 1;
  }

  return -1;
}

void *FloatTable::lookup ( float number, int *rordernumber ) {
  int pos = ordernumber ( number );
  if ( pos == -1 )
    return NULL;
  if ( rordernumber )
    *rordernumber = pos;
  return array[pos].data;
}
