/***************************************************************************
                          floattable.h  -  description
                             -------------------
    begin                : Sun Jul 2 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FLOATTABLE_H
#define FLOATTABLE_H
#include <stdlib.h>


/**A table which translates floats to data
  *@author Siegfried Nijssen
  */

class FloatTable {
  public:
    FloatTable ( int maxsize );
    bool add ( float number, void *data ); // returns false if number exists already
    void* lookup ( float number, int *rordernumber = NULL );
    int ordernumber ( float number );
    float lookup ( int n, void **fdata = NULL ) { 
      if ( fdata ) *fdata = array[n].data;
      return array[n].number;
    }
    ~FloatTable ();
  private:
    struct TableElt {
      float number;
      void *data;
    } *array;
    int usedsize;
};

#endif
