/***************************************************************************
                          main.cpp  - main for console
                                      interface farmer
                             -------------------
    begin                : Tue Mar 21 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "parser.h"
#include "interpreter.h"
#include "globaldata.h"
#include "modefacttable.h"
#include "tree.h"
#include "extern.h"
#include "output.h"
#include <iostream>
#include <iomanip>
#include <time.h>

using namespace std;

void header () {
  cerr << "************ " << endl
       << "** Farmer ** " << endl
       << "************ " << endl
       << "Discovery of frequent queries" << endl
       << "Siegfried Nijssen 2000-2003" << endl;
}

int timedif ( timeval &tv1, timeval &tv2 ) {
  return ( tv2.tv_sec - tv1.tv_sec )* 1000 + ( tv2.tv_usec - tv1.tv_usec ) / 1000;
}

main ( int argc, char *argv[] ) {
  char *filename;
  clock_t t1, t2, t3;
  int rc = 0;

  header ();
  if ( argc != 2 ) {
    ERR << "No input file!" << endl;
    ERR_F
    stopFarmer ();
  }
  filename = argv[1];
  t1 = clock ();
  if ( !parse ( filename, interpret, 'f' ) )
    stopFarmer ();
  ERR << "[ Finished reading input ]" << endl; ERR_F
  modetable.fillDependencies ();
  ERR << "[ Extern initialization ]" << endl; ERR_F
  extern_init ();
  modetable.print ();
  ERR << "[ Starting search ]" << endl; ERR_F

  t2 = clock ();
  print ();
  t3 = clock ();

  OUT << "[ Initialization time " << ( (double) ( t2 - t1 ) ) / CLOCKS_PER_SEC << "s ]" << endl;
  OUT << "[ Computation time " << ( (double) ( t3 - t2 ) ) / CLOCKS_PER_SEC << "s ]" << endl;
  OUT_F
  
  ERR << "[ Search finished ]" << endl; ERR_F
}




