/***************************************************************************
                          modefacttable.cpp  -  storage for
			                        facts that occur in
						modes with outputs
                             -------------------
    begin                : Tue Apr 11 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "modefacttable.h"
#include "typetable.h"
#include "type.h"
#include <stdlib.h>

ModeFactTable::ModeFactTable( TypeTable &typetable, ModeData *modedata ) {
  this->modedata = modedata;
  outputdim = modedata->nroutput;
  inputdim = modedata->size - outputdim;
  data = new FMultiArray<ListModeFactCoorsStore> ( inputdim );
  int nroflists = 0;
  int sumoflistlengths = 0;
}

ModeFactTable::~ModeFactTable() {
  delete data;
}

ListModeFactCoorsStore::ListModeFactCoorsStore () {
  first = NULL;
}

ListModeFactCoorsStore::~ListModeFactCoorsStore () {
  ListModeFactCoorsElement *temp;
  while ( first ) {
    temp = first->next;
    delete first;
    first = temp;
  }
}

void ModeFactTable::setFact ( INTTYPE *coor ) {
  ListModeFactCoorsElement *coorle = new ListModeFactCoorsElement;
  coorle->value = new INTTYPE[outputdim];
  INTTYPE coors[inputdim];
  int j = 0, k, l = 0;
  for ( k = 0; k < modedata->size; k++ )
    if ( IS_OUTPUT_PARAM ( modedata->params + k ) )
      coorle->value[j++] = coor[k];
    else
      coors[l++] = coor[k];
  ListModeFactCoorsStore *store = data->element ( coors );
  if ( !store ) {
    data->insertAt ( coors, store = new ListModeFactCoorsStore );
    nroflists++;
  }
  coorle->next = store->first;
  store->first = coorle;
  sumoflistlengths++;
}
