/***************************************************************************
                          nametable.h  - implements a loop-up table
                             -------------------
    begin                : Tue Mar 21 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef NAMETABLE_H
#define NAMETABLE_H
#include <stdlib.h>

#define TABLESIZE 211

class NameTable {
  public:
    NameTable ();
    ~NameTable ();
    int add ( char *name, void *data = NULL ); // returns order number
    void *lookup ( char *name, int *ordernumber = NULL );
    int ordernumber ( char *name );
    char *lookup ( int n, void **fdata = NULL );
    int size () { return nrofnames; }
    void first () { walk = allnamesfirst; }
    void next () { walk = walk->tnext; }
    bool current ( char *&name, void *&data, int &ordernumber ) {
      if ( !walk )
        return false;
      name = walk->name;
      data = walk->data;
      ordernumber = walk->ordernumber;
      return true;
    }
  private:
    struct TableListElt {
      char *name;
      void *data;
      int ordernumber;
      TableListElt *next;
      TableListElt *tnext;
    };
    TableListElt *array[TABLESIZE];
    TableListElt *allnamesfirst, *allnameslast;
    TableListElt *walk;
    int nrofnames;
};

#endif
