/***************************************************************************
                          predicatetable.cpp  -  the dictionary of
			                         predicates
                             -------------------
    begin                : Tue Mar 21 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <iostream>
#include <iomanip>
#include <string.h>
#include <values.h>
#include "predicatetable.h"
#include "type.h"

using namespace std;

PredicateTable::PredicateTable (){
  maxsize = 0;
}

PredicateTable::~PredicateTable () {
  for ( int i = 0; i < array.size (); i++ )
    if ( array[i] != NULL )
      delete array[i];
}


/** add a predicate to the table */
void PredicateTable::addPredicate ( char *predicate_name, int size, int *params ) {
  PredicateData *data = new PredicateData;
  data = new PredicateData;
  data->name = strdup ( predicate_name );
  data->nr = array.size ();
  data->params = params;
  data->size = size;
  if ( size > maxsize )
    maxsize = size;
  data->filln = 0;
  data->key = false;
  data->facttable = NULL;
  data->number = INT_MAX;
  predicatenames.add ( predicate_name, data );
  array.append ( data );
}

PredicateData *PredicateTable::getPredicate ( char *predicate_name ) {
  return (PredicateData*) predicatenames.lookup ( predicate_name );
}

void PredicateTable::print () {
  int i, j;

  cout << "+--------------+----+------------------+" << endl
       << "| Predicate    | Nr | Param Types      |" << endl
       << "+--------------+----+------------------+" << endl;
  for ( i = 0; i < array.size (); i++ ) {
    cout << "| " << setw ( 12 ) << array[i]->name << " |" << setw ( 3 ) << array[i]->nr << " |";
    for ( j = 0; j < array[i]->size - 1; j++ )
      cout << setw ( 3 ) << array[i]->params[j] << ",";
    cout << setw ( 3 ) << array[i]->params[j]
         << setw ( 16 - j * 4 ) << "|" << endl;
  }
  cout << "+--------------+----+------------------+" << endl;
}

void setFact ( PredicateData *pd, INTTYPE *coors ) {
  for ( int k = 0; k < pd->modes.size (); k++ ) {
    setFact ( pd->modes[k], coors );
  }
}

FArray<int> *isPKeySubSetOfMode ( FArray<bool> *pkey, ModeData *mode ) {
  int size = mode->size;
  FArray<int> *pos = new FArray<int>;
  
  for ( int i = 0; i < size; i++ ) {
    if ( (*pkey)[i] == true ) 
      if ( mode->params[i].type == MinEx ) {
	delete pos;
        return NULL;
      }
      else
        pos->append ( i );
    
  }
  return pos;
}
