/***************************************************************************
                          predicatetable.h  -  the dictionary
			                       of predicates
                             -------------------
    begin                : Tue Mar 21 2000
    copyright            : (C) 2000 by Siegfried Nijssen
    email                : snijssen@cs.leidenuniv.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREDICATETABLE_H
#define PREDICATETABLE_H
#include "nametable.h"
#include "modetable.h"
#include "type.h"
#include "farray.h"

/**A table containing the names of predicates and their numbers
  *@author Siegfried Nijssen
  */

class BaseFactTable;

FArray<int> *isPKeySubSetOfMode ( FArray<bool> *pkey, ModeData *mode );

struct PredicateData {
  char *name;
  int nr;
  int size;
  int number;
  int *params;
  FArray<ModeData *> modes;
  int filln; // fillin used by modetable.fillDependencies
  bool key;
  BaseFactTable *facttable;
  FList<FArray<bool> *> *primarykeys;
};

void setFact ( PredicateData *pd, INTTYPE *coors );

class PredicateTable {
  public:
  	PredicateTable();
  	~PredicateTable();
      /** add a predicate to the table */
    void addPredicate ( char *predicate_name, int size, int *params );
    PredicateData *getPredicate ( char *predicate_name );
    inline PredicateData *getPredicate ( int nr ) const { return array[nr]; } // deprecated
    void print ();
    inline PredicateData *predicateData ( int i ) const { return array[i]; }
    inline int size () const { return array.size (); }
    inline int maxNParams () const { return maxsize; }
  private:
    FArray<PredicateData*> array;
    NameTable predicatenames;
    int maxsize;
};

#endif
